/*---------------------------------------------------------------------*/
/* --- STC MCU Limited ------------------------------------------------*/
/* --- STC 1T Series MCU Demo Programme -------------------------------*/
/* --- Mobile: (86)13922805190 ----------------------------------------*/
/* --- Fax: 86-0513-55012956,55012947,55012969 ------------------------*/
/* --- Tel: 86-0513-55012928,55012929,55012966 ------------------------*/
/* --- Web: www.STCAI.com ---------------------------------------------*/
/* --- BBS: www.STCAIMCU.com  -----------------------------------------*/
/* --- QQ:  800003751 -------------------------------------------------*/
/* Ҫڳʹô˴,ڳעʹSTCϼ        */
/*---------------------------------------------------------------------*/

#include "stc.h"
#include "uart.h"
#include "usb.h"
#include "usb_req_class.h"
#include "util.h"

BOOL UartBusy;



BYTE Count7F;

void uart_init()
{
    SCON = 0x50;
    TMOD &= ~0xf0;
    TL1 = BR(115200);
    TH1 = BR(115200) >> 8;
    AUXR |= T1x12;
    TR1 = 1;
    IP |= 0x10;     //ߴ1жȼֹݶʧ
    ES = 1;
    

    LineCoding.dwDTERate = REV4(115200);
    LineCoding.bCharFormat = 0;
    LineCoding.bParityType = 0;
    LineCoding.bDataBits = 8;


    
    UsbOutBusy = 0;
    RxRptr = 0;
    RxWptr = 0;
    TxRptr = 0;
    TxWptr = 0;
    
    Count7F = 0;
}

void uart1_isr() interrupt UART1_VECTOR
{
    if(RI)
    {
        RI = 0;
        TxBuffer[TxWptr++] = SBUF;
    }

    if(TI)
    {
        TI = 0;
        UartBusy = 0;
    }
}

void uart_set_parity(BYTE parity)
{

        switch (parity)
        {
        default:
        case NONE_PARITY:
            SCON = 0x50;
            break;
        case ODD_PARITY:
        case EVEN_PARITY:
        case MARK_PARITY:
            SCON = 0xd8;
            break;
        case SPACE_PARITY:
            SCON = 0xd0;
            break;
        }
}
void uart_set_baud(DWORD baud)
{
    WORD temp;
	temp = (WORD)BR(baud);
    TL1 = temp;
    TH1 = temp >> 8;
}

void uart_polling()
{
    BYTE dat;
    BYTE cnt;

    if (DeviceState != DEVSTATE_CONFIGURED)  //USBûɣֱ˳
        return;

    if (!UsbInBusy && (TxRptr != TxWptr))
    {
        IE2 &= ~0x80;   //EUSB = 0;
        UsbInBusy = 1;
        usb_write_reg(INDEX, 2);
        cnt = 0;
        while (TxRptr != TxWptr)
        {
            usb_write_reg(FIFO2, TxBuffer[TxRptr++]);
            cnt++;
            if (cnt == EP2IN_SIZE) break;
        }
        usb_write_reg(INCSR1, INIPRDY);
        IE2 |= 0x80;    //EUSB = 1;
    }

    if (!UartBusy && (RxRptr != RxWptr))
    {
        dat = RxBuffer[RxRptr++];
        UartBusy = 1;
        switch (LineCoding.bParityType)
        {
        case NONE_PARITY:
        case SPACE_PARITY:
            TB8 = 0;
            break;
        case ODD_PARITY:
            ACC = dat;
            TB8 = !P;
            break;
        case EVEN_PARITY:
            ACC = dat;
            TB8 = P;
            break;
        case MARK_PARITY:
            TB8 = 1;
            break;
        }
        SBUF = dat;
//        while (UsbOutBusy);
        
#ifdef ISPPWRCTRL
        //ISPʱ7Fм
        {
            extern BYTE IspCount7F;
            
            if (dat == 0x7f)
                IspCount7F++;
            else
                IspCount7F = 0;
        }
#endif
    }


    if (UsbOutBusy)
    {
        IE2 &= ~0x80;   //EUSB = 0;
        if ((BYTE)(RxWptr - RxRptr) < (BYTE)(256 - EP2OUT_SIZE))
        {
            UsbOutBusy = 0;
            usb_write_reg(INDEX, 2);
            usb_write_reg(OUTCSR1, 0);
        }
        IE2 |= 0x80;    //EUSB = 1;
    }

}
